let
  currentTheme = catppuccin-macchiato;
  # Ayu
  ayu-dark = "ayu-dark";
  ayu-light = "ayu-light";
  ayu-mirage = "ayu-mirage";
  # Catppuccin
  catppuccin-latte = "catppuccin-latte";
  catppuccin-frappe = "catppuccin-frappe";
  catppuccin-macchiato = "catppuccin-macchiato";
  catppuccin-mocha = "catppuccin-mocha";
  # Cobalt
  cobalt2 = "cobalt2";
  # Dracula
  dracula = "dracula";
  # Gruvbox
  gruvbox-dark = "gruvbox-dark";
  gruvbox-light = "gruvbox-light";
  # Houston
  houston = "houston";
  # Kanagawa
  kanagawa-dragon = "kanagawa-dragon";
  kanagawa-lotus = "kanagawa-lotus";
  kanagawa-wave = "kanagawa-wave";
  # Laserwave
  laserwave = "laserwave";
  #Lunar
  lunar = "lunar";
  # Material
  material-darker = "material-darker";
  material-deep-ocean = "material-deep-ocean";
  material-forest = "material-forest";
  material-lighter = "material-lighter";
  material-oceanic = "material-oceanic";
  material-palenight = "material-palenight";
  material-sandy-beach = "material-sandy-beach";
  material-sky-blue = "material-sky-blue";
  material-space = "material-space";
  material-volcano = "material-volcano";
  # Monokai
  monokai = "monokai";
  # Night Owl
  night-owl = "night-owl";
  # Nord
  nord = "nord";
  #Ocean Next
  ocean-next = "ocean-next";
  # One Dark
  one-dark = "one-dark";
  # Plastic
  plastic = "plastic";
  # Poimandres
  poimandres-base = "poimandres-base";
  poimandres-storm = "poimandres-storm";
  # Rosepine
  rosepine = "rosepine";
  rosepine-moon = "rosepine-moon";
  rosepine-dawn = "rosepine-dawn";
  # Tokyo Night
  tokyo-night-night = "tokyo-night-night";
  tokyo-night-storm = "tokyo-night-storm";
  tokyo-night-day = "tokyo-night-day";
  # Solorized
  solorized-dark = "solorized-dark";
  solorized-light = "solorized-light";
  # Synthwave 84
  synthwave-84 = "synthwave-84";
  # Vesper
  vesper = "vesper";
  # Wasp
  wasp = "wasp";

  errorMessage = "Unknown theme: ${currentTheme}";

  schemePath = ./schemes;

  mkThemeMap = themes: themeColours:
    if currentTheme == builtins.head themes
    then builtins.head themeColours
    else if themes == []
    then throw errorMessage
    else mkThemeMap (builtins.tail themes) (builtins.tail themeColours);

  mapColour =
    # Ayu
    ayu-darkColour: ayu-lightColour: ayu-mirageColour:
    # Catppuccin
    catppuccin-frappeColour: catppuccin-latteColour: catppuccin-macchiatoColour: catppuccin-mochaColour:
    # Cobalt2
    cobalt2Colour:
    # Dracula
    draculaColour:
    # Gruvbox
    gruvbox-darkColour: gruvbox-lightColour:
    # Houston
    houstonColour:
    # Kanagawa
    kanagawa-dragonColour: kanagawa-lotusColour: kanagawa-waveColour:
    # Laserwave
    laserwaveColour:
    # Lunar
    lunarColour:
    # Material
    material-darkerColour: material-deep-oceanColour: material-forestColour: material-lighterColour: material-oceanicColour: material-palenightColour: material-sandy-beachColour: material-sky-blueColour: material-spaceColour: material-volcanoColour:
    # Monokai
    monokaiColour:
    # Night Owl
    night-owlColour:
    # Nord
    nordColour:
    # Ocean Next
    ocean-nextColour:
    # One Dark
    one-darkColour:
    # Plastic
    plasticColour:
    # Poimandres
    poimandres-baseColour: poimandres-stormColour:
    # Rosepine
    rosepineColour: rosepine-moonColour: rosepine-dawnColour:
    # Tokyo Night
    tokyo-night-nightColor: tokyo-night-stormColor: tokyo-night-dayColor:
    # Solorized
    solorized-darkColour: solorized-lightColour:
    # Synthwave 84
    synthwave-84Colour:
    # Vesper
    vesperColour:
    # Wasp
    waspColour:
      mkThemeMap [
        # Ayu
        ayu-dark
        ayu-light
        ayu-mirage
        # Catppuccin
        catppuccin-frappe
        catppuccin-latte
        catppuccin-macchiato
        catppuccin-mocha
        # Cobalt2
        cobalt2
        # Dracula
        dracula
        # Gruvbox
        gruvbox-dark
        gruvbox-light
        # Houston
        houston
        # Kanagawa
        kanagawa-dragon
        kanagawa-lotus
        kanagawa-wave
        # Laserwave
        laserwave
        # Lunar
        lunar
        # Material
        material-darker
        material-deep-ocean
        material-forest
        material-lighter
        material-oceanic
        material-palenight
        material-sandy-beach
        material-sky-blue
        material-space
        material-volcano
        # Monokai
        monokai
        # Night Owl
        night-owl
        # Nord
        nord
        # Ocean Next
        ocean-next
        # One Dark
        one-dark
        # Plastic
        plastic
        # Poimandres
        poimandres-base
        poimandres-storm
        # Rosepine
        rosepine
        rosepine-moon
        rosepine-dawn
        # Tokyo Night
        tokyo-night-night
        tokyo-night-storm
        tokyo-night-day
        # Solorized
        solorized-dark
        solorized-light
        # Synthwave 84
        synthwave-84
        # Vesper
        vesper
        # Wasp
        wasp
      ] [
        # Ayu
        ayu-darkColour
        ayu-lightColour
        ayu-mirageColour
        # Catppuccin
        catppuccin-frappeColour
        catppuccin-latteColour
        catppuccin-macchiatoColour
        catppuccin-mochaColour
        # Cobalt2
        cobalt2Colour
        # Dracula
        draculaColour
        # Gruvbox
        gruvbox-darkColour
        gruvbox-lightColour
        # Houston
        houstonColour
        # Kanagawa
        kanagawa-dragonColour
        kanagawa-lotusColour
        kanagawa-waveColour
        # Laserwave
        laserwaveColour
        # Lunar
        lunarColour
        # Material
        material-darkerColour
        material-deep-oceanColour
        material-forestColour
        material-lighterColour
        material-oceanicColour
        material-palenightColour
        material-sandy-beachColour
        material-sky-blueColour
        material-spaceColour
        material-volcanoColour
        # Monokai
        monokaiColour
        # Night Owl
        night-owlColour
        # Nord
        nordColour
        # Ocean Next
        ocean-nextColour
        # One Dark
        one-darkColour
        # Plastic
        plasticColour
        # Poimandres
        poimandres-baseColour
        poimandres-stormColour
        # Rosepine
        rosepineColour
        rosepine-moonColour
        rosepine-dawnColour
        # Tokyo Night
        tokyo-night-nightColor
        tokyo-night-stormColor
        tokyo-night-dayColor
        # Solorized
        solorized-darkColour
        solorized-lightColour
        # Synthwave 84
        synthwave-84Colour
        # Vesper
        vesperColour
        # Wasp
        waspColour
      ];
in {
  themes = {
    currentTheme = currentTheme;
    font = "MonaspiceRn Nerd Font";
    schemes = let
      ayuPath = /ayu;
      catppuccinPath = /catppuccin;
      gruvboxPath = /gruvbox;
      kanagawaPath = /kanagawa;
      materialPath = /material;
      poimandresPath = /poimandres;
      rosepinePath = /rosepine;
      toyko-nightPath = /tokyo-night;
      solarizedPath = /solarized;
    in {
      ${ayu-dark} = import (schemePath + ayuPath + /dark);
      ${ayu-light} = import (schemePath + ayuPath + /light);
      ${ayu-mirage} = import (schemePath + ayuPath + /mirage);
      ${catppuccin-frappe} = import (schemePath + catppuccinPath + /frappe);
      ${catppuccin-latte} = import (schemePath + catppuccinPath + /latte);
      ${catppuccin-macchiato} = import (schemePath + catppuccinPath + /macchiato);
      ${catppuccin-mocha} = import (schemePath + catppuccinPath + /mocha);
      ${cobalt2} = import (schemePath + /cobalt2);
      ${dracula} = import (schemePath + /dracula);
      ${gruvbox-dark} = import (schemePath + gruvboxPath + /dark);
      ${gruvbox-light} = import (schemePath + gruvboxPath + /light);
      ${houston} = import (schemePath + /houston);
      ${kanagawa-dragon} = import (schemePath + kanagawaPath + /kanagawa);
      ${kanagawa-lotus} = import (schemePath + kanagawaPath + /kanagawa);
      ${kanagawa-wave} = import (schemePath + kanagawaPath + /kanagawa);
      ${laserwave} = import (schemePath + /laserwave);
      ${lunar} = import (schemePath + /lunar);
      ${material-darker} = import (schemePath + materialPath + /darker);
      ${material-lighter} = import (schemePath + materialPath + /lighter);
      ${material-oceanic} = import (schemePath + materialPath + /oceanic);
      ${material-palenight} = import (schemePath + materialPath + /palenight);
      ${material-deep-ocean} = import (schemePath + materialPath + /deep-ocean);
      ${material-forest} = import (schemePath + materialPath + /forest);
      ${material-sky-blue} = import (schemePath + materialPath + /sky-blue);
      ${material-sandy-beach} = import (schemePath + materialPath + /sandy-beach);
      ${material-volcano} = import (schemePath + materialPath + /volcano);
      ${material-space} = import (schemePath + materialPath + /space);
      ${monokai} = import (schemePath + /monokai);
      ${night-owl} = import (schemePath + /night-owl);
      ${nord} = import (schemePath + /nord);
      ${ocean-next} = import (schemePath + /ocean-next);
      ${one-dark} = import (schemePath + /one-dark);
      ${poimandres-base} = import (schemePath + poimandresPath + /base);
      ${poimandres-storm} = import (schemePath + poimandresPath + /storm);
      ${rosepine} = import (schemePath + rosepinePath + /base);
      ${rosepine-dawn} = import (schemePath + rosepinePath + /dawn);
      ${rosepine-moon} = import (schemePath + rosepinePath + /moon);
      ${tokyo-night-night} = import (schemePath + toyko-nightPath + /night);
      ${tokyo-night-storm} = import (schemePath + toyko-nightPath + /storm);
      ${tokyo-night-day} = import (schemePath + toyko-nightPath + /day);
      ${solorized-dark} = import (schemePath + solarizedPath + /dark);
      ${solorized-light} = import (schemePath + solarizedPath + /light);
      ${synthwave-84} = import (schemePath + /synthwave-84);
      ${vesper} = import (schemePath + /vesper);
      ${wasp} = import (schemePath + /wasp);
    };
    currentColours = {
      # Core Text Colours
      text =
        mapColour
        "text" # catppuccin-frappe
        
        "text" # catppuccin-latte
        
        "text" # catppuccin-macchiato
        
        "text" # catppuccin-mocha
        
        "text" # rosepine
        
        "foreground"; # dracula

      subtext0 =
        mapColour
        "subtext0" # catppuccin-frappe
        
        "subtext0" # catppuccin-latte
        
        "subtext0" # catppuccin-macchiato
        
        "subtext0" # catppuccin-mocha
        
        "muted" # rosepine
        
        "foreground"; # dracula

      subtext1 =
        mapColour
        "subtext1" # catppuccin-frappe
        
        "subtext1" # catppuccin-latte
        
        "subtext1" # catppuccin-macchiato
        
        "subtext1" # catppuccin-mocha
        
        "subtle" # rosepine
        
        "foreground"; # dracula
      # Background Colours
      background0 =
        mapColour
        "crust" # catppuccin-frappe
        
        "crust" # catppuccin-latte
        
        "crust" # catppuccin-macchiato
        
        "crust" # catppuccin-mocha
        
        "highlight0" # rosepine
        
        "background"; # dracula
      background1 =
        mapColour
        "base" # catppuccin-frappe
        
        "base" # catppuccin-latte
        
        "base" # catppuccin-macchiato
        
        "base" # catppuccin-mocha
        
        "base" # rosepine
        
        "background"; # dracula

      background2 =
        mapColour
        "mantle" # catppuccin-frappe
        
        "mantle" # catppuccin-latte
        
        "mantle" # catppuccin-macchiato
        
        "mantle" # catppuccin-mocha
        
        "surface" # rosepine
        
        "background"; # dracula

      # Surface Colours
      surface0 =
        mapColour
        "surface0" # catppuccin-frappe
        
        "surface0" # catppuccin-latte
        
        "surface0" # catppuccin-macchiato
        
        "surface0" # catppuccin-mocha
        
        "highlight0" # rosepine
        
        "background"; # dracula

      surface1 =
        mapColour
        "surface1" # catppuccin-frappe
        
        "surface1" # catppuccin-latte
        
        "surface1" # catppuccin-macchiato
        
        "surface1" # catppuccin-mocha
        
        "highlight1" # rosepine
        
        "background"; # dracula

      surface2 =
        mapColour
        "surface2" # catppuccin-frappe
        
        "surface2" # catppuccin-latte
        
        "surface2" # catppuccin-macchiato
        
        "surface2" # catppuccin-mocha
        
        "highlight2" # rosepine
        
        "background"; # dracula

      # Overlay Colours
      overlay0 =
        mapColour
        "overlay0" # catppuccin-frappe
        
        "overlay0" # catppuccin-latte
        
        "overlay0" # catppuccin-macchiato
        
        "overlay0" # catppuccin-mocha
        
        "muted" # rosepine
        
        "background"; # dracula
      overlay1 =
        mapColour
        "overlay1" # catppuccin-frappe
        
        "overlay1" # catppuccin-latte
        
        "overlay1" # catppuccin-macchiato
        
        "overlay1" # catppuccin-mocha
        
        "subtle" # rosepine
        
        "background"; # dracula

      overlay2 =
        # and comments
        mapColour
        "overlay2" # catppuccin-frappe
        
        "overlay2" # catppuccin-latte
        
        "overlay2" # catppuccin-macchiato
        
        "overlay2" # catppuccin-mocha
        
        "subtle" # rosepine
        
        "background"; # dracula
      # Diagnostic Colours
      error =
        mapColour
        "red" # catppuccin-frappe
        
        "red" # catppuccin-latte
        
        "red" # catppuccin-macchiato
        
        "red" # catppuccin-mocha
        
        "love" # rosepine
        
        "red"; # dracula
      warning =
        mapColour
        "yellow" # catppuccin-frappe
        
        "yellow" # catppuccin-latte
        
        "yellow" # catppuccin-macchiato
        
        "yellow" # catppuccin-mocha
        
        "gold" # rosepine
        
        "yellow"; # dracula
      noError =
        mapColour
        "green" # catppuccin-frappe
        
        "green" # catppuccin-latte
        
        "green" # catppuccin-macchiato
        
        "green" # catppuccin-mocha
        
        "pine" # rosepine
        
        "green"; # dracula

      label =
        mapColour
        "rosewater" # catppuccin-frappe
        
        "rosewater" # catppuccin-latte
        
        "rosewater" # catppuccin-macchiato
        
        "rosewater" # catppuccin-mocha
        
        "rose" # rosepine
        
        "pink"; # dracula
      selection =
        mapColour
        "flamingo" # catppuccin-latte
        
        "flamingo" # catppuccin-frappe
        
        "flamingo" # catppuccin-macchiato
        
        "flamingo" # catppuccin-mocha
        
        "rose" # rosepine
        
        "pink"; # dracula
      keyword =
        mapColour
        "mauve" # catppuccin-frappe
        
        "mauve" # catppuccin-latte
        
        "mauve" # catppuccin-macchiato
        
        "mauve" # catppuccin-mocha
        
        "iris" # rosepine
        
        "purple"; # dracula
      parameter =
        mapColour
        "maroon" # catppuccin-frappe
        
        "maroon" # catppuccin-latte
        
        "maroon" # catppuccin-macchiato
        
        "maroon" # catppuccin-mocha
        
        "love" # rosepine
        
        "orange"; # dracula
      constant =
        mapColour
        "peach" # catppuccin-frappe
        
        "peach" # catppuccin-latte
        
        "peach" # catppuccin-macchiato
        
        "peach" # catppuccin-mocha
        
        "gold" # rosepine
        
        "orange"; # dracula
      regex =
        mapColour
        "pink" # catppuccin-frappe
        
        "pink" # catppuccin-latte
        
        "pink" # catppuccin-macchiato
        
        "pink" # catppuccin-mocha
        
        "love" # rosepine
        
        "purple"; # dracula

      character =
        mapColour
        "teal" # catppuccin-frappe
        
        "teal" # catppuccin-latte
        
        "teal" # catppuccin-macchiato
        
        "teal" # catppuccin-mocha
        
        "foam" # rosepine
        
        "comment"; # dracula
      # Cool Accent Colours
      operator =
        mapColour
        "sky" # catppuccin-frappe
        
        "sky" # catppuccin-latte
        
        "sky" # catppuccin-macchiato
        
        "sky" # catppuccin-mocha
        
        "foam" # rosepine
        
        "cyan"; # dracula
      constructor =
        mapColour
        "sapphire" # catppuccin-frappe
        
        "sapphire" # catppuccin-latte
        
        "sapphire" # catppuccin-macchiato
        
        "sapphire" # catppuccin-mocha
        
        "foam" # rosepine
        
        "cyan"; # dracula
      function =
        mapColour
        "blue" # catppuccin-frappe
        
        "blue" # catppuccin-latte
        
        "blue" # catppuccin-macchiato
        
        "blue" # catppuccin-mocha
        
        "pine" # rosepine
        
        "comment"; # dracula
      link =
        mapColour
        "lavender" # catppuccin-frappe
        
        "lavender" # catppuccin-latte
        
        "lavender" # catppuccin-macchiato
        
        "lavender" # catppuccin-mocha
        
        "iris" # rosepine
        
        "cyan"; # dracula
    };
  };
}
